image: golang:latest
services:
  - docker:dind

stages:
  - build
  - archive-in-s3
  - restart

variables:
  S3_BUCKET_NAME: "m2m.nygard.build.david"
  REPO_NAME: gitlab.com/david.voelkel/m2m.munich
  STUDENT_ID: "david"

build-request:
  image: maven:3.5.3-jdk-8-alpine
  stage: build
  script: 
    - cd m2m.request   
    - mvn clean package
  artifacts:
    paths:
      - ./m2m.request/target/m2m.request.jar
        
lobster-build:
  image: ruby:latest
  stage: build
  script: 
    - cd lobsters
    - bundle package
    - cd .. 
    - tar cvzf lobsters.tgz lobsters
  artifacts:
    paths:
      - lobsters.tgz

router-build:
  image: node:8.12.0-alpine
  stage: build
  script: 
    - cd m2m.router
    - npm install
    - tar cvzf m2m.router.tar.gz .
    - cd .. 
  artifacts:
    paths:
      - ./m2m.router/m2m.router.tar.gz

deploy:
  image: python:3.6-slim
  stage: archive-in-s3
  script:
    - pip install awscli
    - aws s3 cp ./lobsters.tgz               s3://m2m.nygard.build.david/
    - aws s3 cp ./m2m.request/target/m2m.request.jar s3://m2m.nygard.build.david/
    - aws s3 cp ./m2m.router/m2m.router.tar.gz s3://m2m.nygard.build.david/

restart:
  image: python:3.6-slim
  stage: restart
  script:
    - pip install awscli
    - sh ./infrastructure/aws/bin/recycle-asg.sh eu-central-1 asg-lobster-david
    - sh ./infrastructure/aws/bin/recycle-asg.sh eu-central-1 asg-request-david
    - sh ./infrastructure/aws/bin/recycle-asg.sh eu-central-1 asg-router-david

